﻿init python:
    import random
    import time
    random.seed(time.perf_counter_ns())
    renpy.music.register_channel("sfx1", "sfx", False)
    renpy.music.register_channel("sfx2", "sfx", False)
    renpy.music.register_channel("sfx3", "sfx", False)
    renpy.music.register_channel("sfx4", "sfx", False)
    renpy.music.register_channel("sfx5", "sfx", False)
    class bells_bell:
        def __init__(self, image, sound, offset, channel):
            self.image = image
            self.sound = sound
            self.offset = offset
            self.channel = channel
            self.shaking = 0
            self.parent = None
        def click(self):
            self.shaking = 10
            c = f"sfx{self.channel}"
            renpy.play(self.sound, c)
            self.parent.record(self.channel)
            # self.parent.fire_offset(self.offset)
        def tick(self):
            if self.shaking > 0:
                self.shaking -= 1
            else:
                self.shaking = 0
    class bells_class:
        def __init__(self, bells):
            self.bells = bells
            for i in self.bells:
                i.parent = self
            self.sequence = ""
            self.clicked = ""

            self.stage = "start"
            self.playing = False
            self.current_index = 0
            self.index = 1
            self.wait = 4
            # self.fire_offset = (0,0)
        def start(self):
            if not self.sequence:
                s = ""
                for i in range(10):
                    n = random.choice([1,2,3,4,5])
                    s += str(n)
                self.sequence = s
            
            self.play()
        def click(self, bell):
            b = f"bells/bells_{bell}.ogg"
            c = f"sfx{bell}"
            renpy.play(b, c)
            self.ringing.append(bell)
        def tick(self):
            for i in self.bells:
                i.tick()
        def set_sequence(self, sequence):
            self.sequence = str(sequence)
        def play(self):
            self.current_index = 0
            self.stage = "playing"
        def play_tick(self):
            if self.wait > 0:
                self.wait -= 1
                return
            if self.current_index < self.index:
                bell = self.sequence[self.current_index]
                self.bells[int(bell)-1].click()
                self.current_index += 1
            else:
                self.current_index = 0
                self.stage = "recording"
                self.wait = 4
                self.clicked = ""
        def record(self, bell):
            if self.stage == "recording":
                self.clicked += str(bell)
                self.current_index += 1
                if self.current_index >= self.index:
                    for a,b in zip(self.clicked, self.sequence):
                        if not a == b:
                            self.stage = "fail"
                            return

                    if self.clicked == self.sequence:
                        self.stage = "done"
                        return
                    self.index += 1
                    self.current_index = 0
                    self.stage = "playing"

init:
    image bells_black = Crop((0,0,32,32), "bells/bells.png")
    image bells_red = Crop((32,0,32,32), "bells/bells.png")
    image bells_blue = Crop((64,0,32,32), "bells/bells.png")
    image bells_silver = Crop((96,0,32,32), "bells/bells.png")
    image bells_gold = Crop((0,32,32,32), "bells/bells.png")
    image bells_base = Crop((0,64,128,128), "bells/bells.png")

    image bells_eyes_1 = Crop((32,32,32,8), "bells/bells.png")
    image bells_eyes_2 = Crop((32,40,32,8), "bells/bells.png")
    image bells_eyes_3 = Crop((32,48,32,8), "bells/bells.png")
    image bells_eyes_4 = Crop((32,56,32,8), "bells/bells.png")

    image bells_fire:
        Crop((64,32,16,16), "bells/bells.png")
        .1
        Crop((80,32,16,16), "bells/bells.png")
        .1
        Crop((64,48,16,16), "bells/bells.png")
        .1
        Crop((80,48,16,16), "bells/bells.png")
        .1
        repeat

    default bells_game = bells_class(
        [
            bells_bell("bells_black", "bells/bells_1.ogg", (1,-36), 1),
            bells_bell("bells_red", "bells/bells_2.ogg", (-48,-52), 2),
            bells_bell("bells_blue", "bells/bells_3.ogg", (-31,-4), 3),
            bells_bell("bells_silver", "bells/bells_4.ogg", (33,-4), 4),
            bells_bell("bells_gold", "bells/bells_5.ogg", (49,-52), 5),
        ]
        )
screen overlay_say(message):
    style_prefix "over"
    frame:
        background "#000a" padding 20,20 align .5,.9
        vbox:
            text message  align .5,.5
            hbox  align .5,.5:
                transclude
style over_button:
    background "#000a" padding (20,20)
screen bells(sequence, g = bells_game):
    modal True
    if sequence:
        on "show" action Function(g.set_sequence, sequence)
    if g.stage == "playing":
        for i in ["bells_eyes_1", "bells_eyes_2", "bells_eyes_3", "bells_eyes_4"]:
            add i align .5,.5 at bells_eyes_behind
    fixed fit_first True align .5,1.0:
        at zoom(8, True)
        add "bells_base"
        for i in g.bells:
            button:
                padding 0,0 offset i.offset
                if i.shaking:
                    at bells_shake(4)
                else:
                    at bells_shake
                add i.image
                if not g.playing:
                    action Function(i.click)
        # add "bells_fire" align .5,.5 at bell_fire_offset(g.fire_offset)
    timer .1 repeat True action Function(g.tick)
    if g.stage == "start":
        use overlay_say("It is almost midnight."):
            style_prefix "over"
            button:
                text "Start the ritual."
                action Function(g.start)
    elif g.stage == "playing":
        timer .4 repeat True action Function(g.play_tick)
        text "wait"
    elif g.stage == "recording":
        pass
    elif g.stage == "fail":
        use overlay_say("You've made a mistake.\nBetter luck next time."):
            style_prefix "over"
            button:
                text "OK"
                action Return()
    elif g.stage == "done":
        use overlay_say("You've summoned this ghost\nNow stand back and wait for the summon animation."):
            style_prefix "over"
            button:
                text "OK"
                action Return()
    vbox yalign .5:
        text g.stage
        text g.sequence
        text g.clicked
    
# transform bell_fire_offset(o):
#     ease .1 offset (10,10)
transform bells_eyes_behind:
    nearest True
    alpha 0 xoffset random.randint(-512,512) yoffset random.randint(-512,512)
    ease 2 zoom 8 alpha 1
    repeat
transform bells_shake(s = 0):
    rotate_pad True
    transform_anchor True
    align (.5,.5) yanchor .0 
    rotate -s
    pause .1
    rotate s
    pause .1
    repeat


label bells_example:
    call screen bells(12345)

